#include "mbed.h"
#include "rpc.h"
#include "I2CLCD.h"

Serial pc(USBTX, USBRX);
int main() {
    // setup the classes that can be created dynamically
    Base::add_rpc_class<AnalogIn>();
    Base::add_rpc_class<AnalogOut>();
    Base::add_rpc_class<DigitalIn>();
    Base::add_rpc_class<DigitalOut>();
    Base::add_rpc_class<DigitalInOut>();
    Base::add_rpc_class<PwmOut>();
    Base::add_rpc_class<Timer>();
    Base::add_rpc_class<SPI>();
    Base::add_rpc_class<BusOut>();
    Base::add_rpc_class<BusIn>();
    Base::add_rpc_class<BusInOut>();
    Base::add_rpc_class<Serial>();
    I2CLCD lcd(p28,p27);
    lcd.clear();

    // receive commands, and send back the responses
    char buf[256], outbuf[256];
    lcd.write("RPC_Serial mode\n");
    lcd.write("wait for command");
//    lcd.printf("PC&#65533;&#65533;&#634;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;");
    pc.baud(115200);
    while(1) {
        pc.gets(buf, 256);
        rpc(buf, outbuf);
        pc.printf("%s\n", outbuf);
    }
}
